Index: serefpolicy-contrib-20140730/kdump.te
===================================================================
--- serefpolicy-contrib-20140730.orig/kdump.te
+++ serefpolicy-contrib-20140730/kdump.te
@@ -12,35 +12,56 @@ init_system_domain(kdump_t, kdump_exec_t
 type kdump_etc_t;
 files_config_file(kdump_etc_t)
 
+type kdump_crash_t;
+files_type(kdump_crash_t)
+
 type kdump_initrc_exec_t;
 init_script_file(kdump_initrc_exec_t)
 
+type kdump_unit_file_t alias kdumpctl_unit_file_t;
+systemd_unit_file(kdump_unit_file_t)
+
+type kdump_lock_t;
+files_lock_file(kdump_lock_t)
+
 type kdumpctl_t;
 type kdumpctl_exec_t;
 init_daemon_domain(kdumpctl_t, kdumpctl_exec_t)
-application_executable_file(kdumpctl_exec_t)
+init_initrc_domain(kdumpctl_t)
 
 type kdumpctl_tmp_t;
 files_tmp_file(kdumpctl_tmp_t)
 
 #####################################
 #
-# Local policy
+# kdump local policy
 #
 
 allow kdump_t self:capability { sys_boot dac_override };
+allow kdump_t self:capability2 compromise_kernel;
 
-allow kdump_t kdump_etc_t:file read_file_perms;
+manage_dirs_pattern(kdump_t, kdump_crash_t, kdump_crash_t)
+manage_files_pattern(kdump_t, kdump_crash_t, kdump_crash_t)
+manage_lnk_files_pattern(kdump_t, kdump_crash_t, kdump_crash_t)
+files_var_filetrans(kdump_t, kdump_crash_t, dir, "crash")
+
+read_files_pattern(kdump_t, kdump_etc_t, kdump_etc_t)
+
+manage_dirs_pattern(kdump_t, kdump_lock_t, kdump_lock_t)
+manage_files_pattern(kdump_t, kdump_lock_t, kdump_lock_t)
+manage_lnk_files_pattern(kdump_t, kdump_lock_t, kdump_lock_t)
+files_lock_filetrans(kdump_t, kdump_lock_t, { dir file lnk_file })
 
-files_read_etc_files(kdump_t)
 files_read_etc_runtime_files(kdump_t)
 files_read_kernel_img(kdump_t)
 
+kernel_read_system_state(kdump_t)
 kernel_read_core_if(kdump_t)
 kernel_read_debugfs(kdump_t)
-kernel_read_system_state(kdump_t)
 kernel_request_load_module(kdump_t)
 
+mls_file_read_all_levels(kdump_t)
+
 dev_read_framebuffer(kdump_t)
 dev_read_sysfs(kdump_t)
 
@@ -48,22 +69,35 @@ term_use_console(kdump_t)
 
 #######################################
 #
-# Ctl local policy
+# kdumpctl local policy
 #
 
+#cjp:almost all rules are needed by dracut
+
+kdump_domtrans(kdumpctl_t)
+
 allow kdumpctl_t self:capability { dac_override sys_chroot };
 allow kdumpctl_t self:process setfscreate;
+
 allow kdumpctl_t self:fifo_file rw_fifo_file_perms;
-allow kdumpctl_t self:unix_stream_socket { accept listen };
+allow kdumpctl_t self:unix_stream_socket create_stream_socket_perms;
 
-allow kdumpctl_t kdump_etc_t:file read_file_perms;
+manage_files_pattern(kdumpctl_t, kdump_lock_t, kdump_lock_t)
+files_lock_filetrans(kdumpctl_t, kdump_lock_t, file, "kdump")
 
 manage_dirs_pattern(kdumpctl_t, kdumpctl_tmp_t, kdumpctl_tmp_t)
+manage_chr_files_pattern(kdumpctl_t, kdumpctl_tmp_t, kdumpctl_tmp_t)
 manage_files_pattern(kdumpctl_t, kdumpctl_tmp_t, kdumpctl_tmp_t)
 manage_lnk_files_pattern(kdumpctl_t, kdumpctl_tmp_t, kdumpctl_tmp_t)
 files_tmp_filetrans(kdumpctl_t, kdumpctl_tmp_t, { file dir lnk_file })
+can_exec(kdumpctl_t, kdumpctl_tmp_t)
 
-domtrans_pattern(kdumpctl_t, kdump_exec_t, kdump_t)
+manage_dirs_pattern(kdumpctl_t, kdump_crash_t, kdump_crash_t)
+manage_files_pattern(kdumpctl_t, kdump_crash_t, kdump_crash_t)
+manage_lnk_files_pattern(kdumpctl_t, kdump_crash_t, kdump_crash_t)
+files_var_filetrans(kdumpctl_t, kdump_crash_t, dir, "crash")
+
+read_files_pattern(kdumpctl_t, kdump_etc_t, kdump_etc_t)
 
 kernel_read_system_state(kdumpctl_t)
 
@@ -71,46 +105,56 @@ corecmd_exec_bin(kdumpctl_t)
 corecmd_exec_shell(kdumpctl_t)
 
 dev_read_sysfs(kdumpctl_t)
+# dracut
 dev_manage_all_dev_nodes(kdumpctl_t)
 
 domain_use_interactive_fds(kdumpctl_t)
 
 files_create_kernel_img(kdumpctl_t)
-files_read_etc_files(kdumpctl_t)
 files_read_etc_runtime_files(kdumpctl_t)
-files_read_usr_files(kdumpctl_t)
 files_read_kernel_modules(kdumpctl_t)
 files_getattr_all_dirs(kdumpctl_t)
+files_delete_kernel(kdumpctl_t)
 
 fs_getattr_all_fs(kdumpctl_t)
 fs_search_all(kdumpctl_t)
 
-init_domtrans_script(kdumpctl_t)
+application_executable_ioctl(kdumpctl_t)
+
+auth_read_passwd(kdumpctl_t)
+
 init_exec(kdumpctl_t)
+systemd_exec_systemctl(kdumpctl_t)
+systemd_read_unit_files(kdumpctl_t)
 
 libs_exec_ld_so(kdumpctl_t)
 
 logging_send_syslog_msg(kdumpctl_t)
+# Need log file from /var/log/dracut.log
+logging_write_generic_logs(kdumpctl_t)
 
-miscfiles_read_localization(kdumpctl_t)
+optional_policy(`
+        gpg_exec(kdumpctl_t)
+')
 
 optional_policy(`
-	gpg_exec(kdumpctl_t)
+        lvm_read_config(kdumpctl_t)
 ')
 
 optional_policy(`
-	lvm_read_config(kdumpctl_t)
+        modutils_domtrans_insmod(kdumpctl_t)
+        modutils_list_module_config(kdumpctl_t)
+        modutils_read_module_config(kdumpctl_t)
 ')
 
 optional_policy(`
-	modutils_domtrans_insmod(kdumpctl_t)
-	modutils_read_module_config(kdumpctl_t)
+        plymouthd_domtrans_plymouth(kdumpctl_t)
 ')
 
 optional_policy(`
-	plymouthd_domtrans_plymouth(kdumpctl_t)
+        ssh_exec(kdumpctl_t)
 ')
 
 optional_policy(`
-	ssh_exec(kdumpctl_t)
+	unconfined_domain(kdumpctl_t)
 ')
Index: serefpolicy-contrib-20140730/keepalived.fc
===================================================================
--- /dev/null
+++ serefpolicy-contrib-20140730/keepalived.fc
@@ -0,0 +1,5 @@
+/usr/lib/systemd/system/keepalived.*		--	gen_context(system_u:object_r:keepalived_unit_file_t,s0)
+
+/usr/sbin/keepalived		--	gen_context(system_u:object_r:keepalived_exec_t,s0)
+
+/var/run/keepalived.*		--	gen_context(system_u:object_r:keepalived_var_run_t,s0)
Index: serefpolicy-contrib-20140730/keepalived.if
===================================================================
--- /dev/null
+++ serefpolicy-contrib-20140730/keepalived.if
@@ -0,0 +1,84 @@
+
+## <summary> keepalived - load-balancing and high-availability service</summary>
+
+########################################
+## <summary>
+##	Execute keepalived in the keepalived domin.
+## </summary>
+## <param name="domain">
+## <summary>
+##	Domain allowed to transition.
+## </summary>
+## </param>
+#
+interface(`keepalived_domtrans',`
+	gen_require(`
+		type keepalived_t, keepalived_exec_t;
+	')
+
+	corecmd_search_bin($1)
+	domtrans_pattern($1, keepalived_exec_t, keepalived_t)
+')
+########################################
+## <summary>
+##	Execute keepalived server in the keepalived domain.
+## </summary>
+## <param name="domain">
+##	<summary>
+##	Domain allowed to transition.
+##	</summary>
+## </param>
+#
+interface(`keepalived_systemctl',`
+	gen_require(`
+		type keepalived_t;
+		type keepalived_unit_file_t;
+	')
+
+	systemd_exec_systemctl($1)
+    systemd_read_fifo_file_passwd_run($1)
+	allow $1 keepalived_unit_file_t:file read_file_perms;
+	allow $1 keepalived_unit_file_t:service manage_service_perms;
+
+	ps_process_pattern($1, keepalived_t)
+')
+
+
+########################################
+## <summary>
+##	All of the rules required to administrate
+##	an keepalived environment
+## </summary>
+## <param name="domain">
+##	<summary>
+##	Domain allowed access.
+##	</summary>
+## </param>
+## <param name="role">
+##	<summary>
+##	Role allowed access.
+##	</summary>
+## </param>
+## <rolecap/>
+#
+interface(`keepalived_admin',`
+	gen_require(`
+		type keepalived_t;
+	    type keepalived_unit_file_t;
+	')
+
+	allow $1 keepalived_t:process { signal_perms };
+	ps_process_pattern($1, keepalived_t)
+
+    tunable_policy(`deny_ptrace',`',`
+        allow $1 keepalived_t:process ptrace;
+    ')
+
+	keepalived_systemctl($1)
+	admin_pattern($1, keepalived_unit_file_t)
+	allow $1 keepalived_unit_file_t:service all_service_perms;
+	optional_policy(`
+		systemd_passwd_agent_exec($1)
+		systemd_read_fifo_file_passwd_run($1)
+	')
+')
Index: serefpolicy-contrib-20140730/keepalived.te
===================================================================
--- /dev/null
+++ serefpolicy-contrib-20140730/keepalived.te
@@ -0,0 +1,55 @@
+policy_module(keepalived, 1.0.0)
+
+########################################
+#
+# Declarations
+#
+
+type keepalived_t;
+type keepalived_exec_t;
+init_daemon_domain(keepalived_t, keepalived_exec_t)
+
+type keepalived_unit_file_t;
+systemd_unit_file(keepalived_unit_file_t)
+
+type keepalived_var_run_t;
+files_pid_file(keepalived_var_run_t)
+
+########################################
+#
+# keepalived local policy
+#
+allow keepalived_t self:capability { net_admin net_raw };
+allow keepalived_t self:process { signal_perms };
+allow keepalived_t self:netlink_socket create_socket_perms;
+allow keepalived_t self:netlink_route_socket nlmsg_write;
+allow keepalived_t self:packet_socket create_socket_perms;
+allow keepalived_t self:rawip_socket create_socket_perms;
+
+
+manage_files_pattern(keepalived_t, keepalived_var_run_t, keepalived_var_run_t)
+files_pid_filetrans(keepalived_t, keepalived_var_run_t, { file })
+
+kernel_read_system_state(keepalived_t)
+kernel_read_network_state(keepalived_t)
+
+auth_use_nsswitch(keepalived_t)
+
+corecmd_exec_bin(keepalived_t)
+corecmd_exec_shell(keepalived_t)
+
+corenet_tcp_connect_connlcli_port(keepalived_t)
+corenet_tcp_connect_http_port(keepalived_t)
+corenet_tcp_connect_smtp_port(keepalived_t)
+corenet_tcp_connect_snmp_port(keepalived_t)
+corenet_tcp_connect_agentx_port(keepalived_t)
+
+dev_read_urand(keepalived_t)
+
+modutils_domtrans_insmod(keepalived_t)
+
+logging_send_syslog_msg(keepalived_t)
+
+optional_policy(`
+    snmp_read_snmp_var_lib_files(keepalived_t)
+')
Index: serefpolicy-contrib-20140730/kerberos.fc
===================================================================
--- serefpolicy-contrib-20140730.orig/kerberos.fc
+++ serefpolicy-contrib-20140730/kerberos.fc
@@ -1,52 +1,46 @@
-HOME_DIR/\.k5login	--	gen_context(system_u:object_r:krb5_home_t,s0)
-/root/\.k5login	--	gen_context(system_u:object_r:krb5_home_t,s0)
+HOME_DIR/\.k5login		--	gen_context(system_u:object_r:krb5_home_t,s0)
+/root/\.k5login			--	gen_context(system_u:object_r:krb5_home_t,s0)
 
-/etc/krb5\.conf	--	gen_context(system_u:object_r:krb5_conf_t,s0)
-/etc/krb5\.keytab	--	gen_context(system_u:object_r:krb5_keytab_t,s0)
+/etc/krb5\.conf			--	gen_context(system_u:object_r:krb5_conf_t,s0)
+/etc/krb5\.keytab			gen_context(system_u:object_r:krb5_keytab_t,s0)
 
-/etc/krb5kdc(/.*)?	gen_context(system_u:object_r:krb5kdc_conf_t,s0)
-/etc/krb5kdc/kadm5\.keytab	--	gen_context(system_u:object_r:krb5_keytab_t,s0)
-/etc/krb5kdc/principal.*	gen_context(system_u:object_r:krb5kdc_principal_t,s0)
+/etc/krb5kdc(/.*)?			gen_context(system_u:object_r:krb5kdc_conf_t,s0)
+/etc/krb5kdc/kadm5\.keytab 	--	gen_context(system_u:object_r:krb5_keytab_t,s0)
+/etc/krb5kdc/principal.*		gen_context(system_u:object_r:krb5kdc_principal_t,s0)
 
 /etc/rc\.d/init\.d/kadmind	--	gen_context(system_u:object_r:kerberos_initrc_exec_t,s0)
 /etc/rc\.d/init\.d/kprop	--	gen_context(system_u:object_r:kerberos_initrc_exec_t,s0)
 /etc/rc\.d/init\.d/krb524d	--	gen_context(system_u:object_r:kerberos_initrc_exec_t,s0)
 /etc/rc\.d/init\.d/krb5kdc	--	gen_context(system_u:object_r:kerberos_initrc_exec_t,s0)
 
-/usr/kerberos/sbin/krb5kdc	--	gen_context(system_u:object_r:krb5kdc_exec_t,s0)
-/usr/kerberos/sbin/kadmind	--	gen_context(system_u:object_r:kadmind_exec_t,s0)
-/usr/kerberos/sbin/kadmin\.local	--	gen_context(system_u:object_r:kadmind_exec_t,s0)
+/usr/(kerberos/)?sbin/krb5kdc -- gen_context(system_u:object_r:krb5kdc_exec_t,s0)
+/usr/(kerberos/)?sbin/kadmind -- gen_context(system_u:object_r:kadmind_exec_t,s0)
+/usr/kerberos/sbin/kadmin\.local --	gen_context(system_u:object_r:kadmind_exec_t,s0)
 /usr/kerberos/sbin/kpropd	--	gen_context(system_u:object_r:kpropd_exec_t,s0)
+/usr/sbin/kpropd	--	gen_context(system_u:object_r:kpropd_exec_t,s0)
 
-/usr/local/kerberos/sbin/krb5kdc	--	gen_context(system_u:object_r:krb5kdc_exec_t,s0)
-/usr/local/kerberos/sbin/kadmind	--	gen_context(system_u:object_r:kadmind_exec_t,s0)
-
-/usr/sbin/krb5kdc	--	gen_context(system_u:object_r:krb5kdc_exec_t,s0)
-/usr/sbin/kadmind	--	gen_context(system_u:object_r:kadmind_exec_t,s0)
-
-/usr/local/var/krb5kdc(/.*)?	gen_context(system_u:object_r:krb5kdc_conf_t,s0)
-/usr/local/var/krb5kdc/principal.*	gen_context(system_u:object_r:krb5kdc_principal_t,s0)
-
-/usr/var/krb5kdc(/.*)?	gen_context(system_u:object_r:krb5kdc_conf_t,s0)
+/usr/var/krb5kdc(/.*)?		gen_context(system_u:object_r:krb5kdc_conf_t,s0)
 /usr/var/krb5kdc/principal.*	gen_context(system_u:object_r:krb5kdc_principal_t,s0)
 
-/var/cache/krb5rcache(/.*)?	gen_context(system_u:object_r:krb5_host_rcache_t,s0)
-
-/var/kerberos/krb5kdc(/.*)?	gen_context(system_u:object_r:krb5kdc_conf_t,s0)
+/var/kerberos/krb5kdc(/.*)?		gen_context(system_u:object_r:krb5kdc_conf_t,s0)
 /var/kerberos/krb5kdc/from_master.*	gen_context(system_u:object_r:krb5kdc_lock_t,s0)
-/var/kerberos/krb5kdc/kadm5\.keytab	--	gen_context(system_u:object_r:krb5_keytab_t,s0)
+/var/kerberos/krb5kdc/kadm5\.keytab --	gen_context(system_u:object_r:krb5_keytab_t,s0)
 /var/kerberos/krb5kdc/principal.*	gen_context(system_u:object_r:krb5kdc_principal_t,s0)
-/var/kerberos/krb5kdc/principal.*\.ok	--	gen_context(system_u:object_r:krb5kdc_lock_t,s0)
+/var/kerberos/krb5kdc/principal.*\.ok	gen_context(system_u:object_r:krb5kdc_lock_t,s0)
+
+/var/log/krb5kdc\.log.*			gen_context(system_u:object_r:krb5kdc_log_t,s0)
+/var/log/kadmin(d)?\.log.*		gen_context(system_u:object_r:kadmind_log_t,s0)
+
+/var/cache/krb5rcache(/.*)?	 	gen_context(system_u:object_r:krb5_host_rcache_t,s0)
+
+/var/run/krb5kdc(/.*)?          gen_context(system_u:object_r:krb5kdc_var_run_t,s0)
 
-/var/log/krb5kdc\.log.*	--	gen_context(system_u:object_r:krb5kdc_log_t,s0)
-/var/log/kadmin\.log.*	--	gen_context(system_u:object_r:kadmind_log_t,s0)
-/var/log/kadmind\.log.*	--	gen_context(system_u:object_r:kadmind_log_t,s0)
-
-/var/tmp/host_0	--	gen_context(system_u:object_r:krb5_host_rcache_t,s0)
-/var/tmp/HTTP_23	--	gen_context(system_u:object_r:krb5_host_rcache_t,s0)
-/var/tmp/HTTP_48	--	gen_context(system_u:object_r:krb5_host_rcache_t,s0)
-/var/tmp/imap_0	--	gen_context(system_u:object_r:krb5_host_rcache_t,s0)
-/var/tmp/nfs_0	--	gen_context(system_u:object_r:krb5_host_rcache_t,s0)
-/var/tmp/ldapmap1_0	--	gen_context(system_u:object_r:krb5_host_rcache_t,s0)
-/var/tmp/ldap_487	--	gen_context(system_u:object_r:krb5_host_rcache_t,s0)
-/var/tmp/ldap_55	--	gen_context(system_u:object_r:krb5_host_rcache_t,s0)
+/var/tmp/DNS_25			-- 	gen_context(system_u:object_r:krb5_host_rcache_t,s0)
+/var/tmp/host_0			-- 	gen_context(system_u:object_r:krb5_host_rcache_t,s0)
+/var/tmp/HTTP_23		-- 	gen_context(system_u:object_r:krb5_host_rcache_t,s0)
+/var/tmp/HTTP_48		-- 	gen_context(system_u:object_r:krb5_host_rcache_t,s0)
+/var/tmp/imap_0			-- 	gen_context(system_u:object_r:krb5_host_rcache_t,s0)
+/var/tmp/nfs_0			-- 	gen_context(system_u:object_r:krb5_host_rcache_t,s0)
+/var/tmp/ldapmap1_0		-- 	gen_context(system_u:object_r:krb5_host_rcache_t,s0)
+/var/tmp/ldap_487		-- 	gen_context(system_u:object_r:krb5_host_rcache_t,s0)
+/var/tmp/ldap_55		-- 	gen_context(system_u:object_r:krb5_host_rcache_t,s0)
Index: serefpolicy-contrib-20140730/kerberos.if
===================================================================
--- serefpolicy-contrib-20140730.orig/kerberos.if
+++ serefpolicy-contrib-20140730/kerberos.if
@@ -1,27 +1,29 @@
-## <summary>MIT Kerberos admin and KDC.</summary>
+## <summary>MIT Kerberos admin and KDC</summary>
+## <desc>
+##	<p>
+##	This policy supports:
+##	</p>
+##	<p>
+##	Servers:
+##	<ul>
+##		<li>kadmind</li>
+##		<li>krb5kdc</li>
+##	</ul>
+##	</p>
+##	<p>
+##	Clients:
+##	<ul>
+##		<li>kinit</li>
+##		<li>kdestroy</li>
+##		<li>klist</li>
+##		<li>ksu (incomplete)</li>
+##	</ul>
+##	</p>
+## </desc>
 
 ########################################
 ## <summary>
-##	Role access for kerberos.
-## </summary>
-## <param name="role">
-##	<summary>
-##	Role allowed access.
-##	</summary>
-## </param>
-## <param name="domain">
-##	<summary>
-##	User domain for the role.
-##	</summary>
-## </param>
-#
-template(`kerberos_role',`
-	refpolicywarn(`$0($*) has been deprecated')
-')
-
-########################################
-## <summary>
-##	Execute kadmind in the caller domain.
+##	Execute kadmind in the current domain
 ## </summary>
 ## <param name="domain">
 ## <summary>
@@ -34,7 +36,6 @@ interface(`kerberos_exec_kadmind',`
 		type kadmind_exec_t;
 	')
 
-	corecmd_search_bin($1)
 	can_exec($1, kadmind_exec_t)
 ')
 
@@ -53,13 +54,12 @@ interface(`kerberos_domtrans_kpropd',`
 		type kpropd_t, kpropd_exec_t;
 	')
 
-	corecmd_search_bin($1)
 	domtrans_pattern($1, kpropd_exec_t, kpropd_t)
 ')
 
 ########################################
 ## <summary>
-##	Support kerberos services.
+##	Use kerberos services
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -69,45 +69,44 @@ interface(`kerberos_domtrans_kpropd',`
 #
 interface(`kerberos_use',`
 	gen_require(`
-		type krb5kdc_conf_t, krb5_host_rcache_t;
+		type krb5_conf_t, krb5kdc_conf_t;
+		type krb5_host_rcache_t;
 	')
 
-	kerberos_read_config($1)
-
-	dontaudit $1 krb5_conf_t:file write_file_perms;
+	files_search_etc($1)
+	read_files_pattern($1, krb5_conf_t, krb5_conf_t)
+	dontaudit $1 krb5_conf_t:file write;
 	dontaudit $1 krb5kdc_conf_t:dir list_dir_perms;
 	dontaudit $1 krb5kdc_conf_t:file rw_file_perms;
 
+	#kerberos libraries are attempting to set the correct file context
 	dontaudit $1 self:process setfscreate;
-
 	selinux_dontaudit_validate_context($1)
-	seutil_dontaudit_read_file_contexts($1)
+	seutil_read_file_contexts($1)
 
-	tunable_policy(`allow_kerberos',`
+	tunable_policy(`kerberos_enabled',`
 		allow $1 self:tcp_socket create_socket_perms;
 		allow $1 self:udp_socket create_socket_perms;
 
-		corenet_all_recvfrom_unlabeled($1)
-		corenet_all_recvfrom_netlabel($1)
 		corenet_tcp_sendrecv_generic_if($1)
 		corenet_udp_sendrecv_generic_if($1)
 		corenet_tcp_sendrecv_generic_node($1)
 		corenet_udp_sendrecv_generic_node($1)
-
-		corenet_sendrecv_kerberos_client_packets($1)
-		corenet_tcp_connect_kerberos_port($1)
 		corenet_tcp_sendrecv_kerberos_port($1)
 		corenet_udp_sendrecv_kerberos_port($1)
-
-		corenet_sendrecv_ocsp_client_packets($1)
+		corenet_tcp_bind_generic_node($1)
+		corenet_udp_bind_generic_node($1)
+		corenet_tcp_connect_kerberos_port($1)
 		corenet_tcp_connect_ocsp_port($1)
-		corenet_tcp_sendrecv_ocsp_port($1)
+		corenet_sendrecv_kerberos_client_packets($1)
+		corenet_sendrecv_ocsp_client_packets($1)
 
+		allow $1 krb5_host_rcache_t:dir search_dir_perms;
 		allow $1 krb5_host_rcache_t:file getattr_file_perms;
 	')
 
 	optional_policy(`
-		tunable_policy(`allow_kerberos',`
+		tunable_policy(`kerberos_enabled',`
 			pcscd_stream_connect($1)
 		')
 	')
@@ -119,7 +118,7 @@ interface(`kerberos_use',`
 
 ########################################
 ## <summary>
-##	Read kerberos configuration files.
+##	Read the kerberos configuration file (/etc/krb5.conf).
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -135,15 +134,13 @@ interface(`kerberos_read_config',`
 
 	files_search_etc($1)
 	allow $1 krb5_conf_t:file read_file_perms;
-
-	userdom_search_user_home_dirs($1)
 	allow $1 krb5_home_t:file read_file_perms;
 ')
 
 ########################################
 ## <summary>
-##	Do not audit attempts to write
-##	kerberos configuration files.
+##	Do not audit attempts to write the kerberos
+##	configuration file (/etc/krb5.conf).
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -156,13 +153,12 @@ interface(`kerberos_dontaudit_write_conf
 		type krb5_conf_t;
 	')
 
-	dontaudit $1 krb5_conf_t:file write_file_perms;
+	dontaudit $1 krb5_conf_t:file write;
 ')
 
 ########################################
 ## <summary>
-##	Read and write kerberos
-##	configuration files.
+##	Read and write the kerberos configuration file (/etc/krb5.conf).
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -182,75 +178,7 @@ interface(`kerberos_rw_config',`
 
 ########################################
 ## <summary>
-##	Create, read, write, and delete
-##	kerberos home files.
-## </summary>
-## <param name="domain">
-##	<summary>
-##	Domain allowed access.
-##	</summary>
-## </param>
-#
-interface(`kerberos_manage_krb5_home_files',`
-	gen_require(`
-		type krb5_home_t;
-	')
-
-	userdom_search_user_home_dirs($1)
-	allow $1 krb5_home_t:file manage_file_perms;
-')
-
-########################################
-## <summary>
-##	Relabel kerberos home files.
-## </summary>
-## <param name="domain">
-##	<summary>
-##	Domain allowed access.
-##	</summary>
-## </param>
-#
-interface(`kerberos_relabel_krb5_home_files',`
-	gen_require(`
-		type krb5_home_t;
-	')
-
-	userdom_search_user_home_dirs($1)
-	allow $1 krb5_home_t:file relabel_file_perms;
-')
-
-########################################
-## <summary>
-##	Create objects in user home
-##	directories with the krb5 home type.
-## </summary>
-## <param name="domain">
-##	<summary>
-##	Domain allowed access.
-##	</summary>
-## </param>
-## <param name="object_class">
-##	<summary>
-##	Class of the object being created.
-##	</summary>
-## </param>
-## <param name="name" optional="true">
-##	<summary>
-##	The name of the object being created.
-##	</summary>
-## </param>
-#
-interface(`kerberos_home_filetrans_krb5_home',`
-	gen_require(`
-		type krb5_home_t;
-	')
-
-	userdom_user_home_dir_filetrans($1, krb5_home_t, $2, $3)
-')
-
-########################################
-## <summary>
-##	Read kerberos key table files.
+##	Read the kerberos key table.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -270,7 +198,7 @@ interface(`kerberos_read_keytab',`
 
 ########################################
 ## <summary>
-##	Read and write kerberos key table files.
+##	Read/Write the kerberos key table.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -289,40 +217,13 @@ interface(`kerberos_rw_keytab',`
 
 ########################################
 ## <summary>
-##	Create, read, write, and delete
-##	kerberos key table files.
-## </summary>
-## <param name="domain">
-##	<summary>
-##	Domain allowed access.
-##	</summary>
-## </param>
-#
-interface(`kerberos_manage_keytab_files',`
-	gen_require(`
-		type krb5_keytab_t;
-	')
-
-	files_search_etc($1)
-	allow $1 krb5_keytab_t:file manage_file_perms;
-')
-
-########################################
-## <summary>
-##	Create specified objects in generic
-##	etc directories with the kerberos
-##	keytab file type.
+##	Create keytab file in /etc
 ## </summary>
 ## <param name="domain">
 ##	<summary>
 ##	Domain allowed access.
 ##	</summary>
 ## </param>
-## <param name="object_class">
-##	<summary>
-##	Class of the object being created.
-##	</summary>
-## </param>
 ## <param name="name" optional="true">
 ##	<summary>
 ##	The name of the object being created.
@@ -334,13 +235,13 @@ interface(`kerberos_etc_filetrans_keytab
 		type krb5_keytab_t;
 	')
 
-	files_etc_filetrans($1, krb5_keytab_t, $2, $3)
+	allow $1 krb5_keytab_t:file manage_file_perms;
+	files_etc_filetrans($1, krb5_keytab_t, file, $2)
 ')
 
 ########################################
 ## <summary>
-##	Create a derived type for kerberos
-##	keytab files.
+##	Create a derived type for kerberos keytab
 ## </summary>
 ## <param name="prefix">
 ##	<summary>
@@ -361,7 +262,7 @@ template(`kerberos_keytab_template',`
 
 ########################################
 ## <summary>
-##	Read kerberos kdc configuration files.
+##	Read the kerberos kdc configuration file (/etc/krb5kdc.conf).
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -381,8 +282,7 @@ interface(`kerberos_read_kdc_config',`
 
 ########################################
 ## <summary>
-##	Create, read, write, and delete
-##	kerberos host rcache files.
+##	Read the kerberos kdc configuration file (/etc/krb5kdc.conf).
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -396,34 +296,99 @@ interface(`kerberos_manage_host_rcache',
 		type krb5_host_rcache_t;
 	')
 
+	# creates files as system_u no matter what the selinux user
+	# cjp: should be in the below tunable but typeattribute
+	# does not work in conditionals
 	domain_obj_id_change_exemption($1)
 
-	tunable_policy(`allow_kerberos',`
+	tunable_policy(`kerberos_enabled',`
 		allow $1 self:process setfscreate;
 
 		selinux_validate_context($1)
 
 		seutil_read_file_contexts($1)
 
+		files_rw_generic_tmp_dir($1)
+		manage_files_pattern($1, krb5_host_rcache_t, krb5_host_rcache_t)
 		files_search_tmp($1)
-		allow $1 krb5_host_rcache_t:file manage_file_perms;
 	')
 ')
 
 ########################################
 ## <summary>
-##	Create objects in generic temporary
-##	directories with the kerberos host
-##	rcache type.
+##	All of the rules required to administrate 
+##	an kerberos environment
 ## </summary>
 ## <param name="domain">
 ##	<summary>
-##	Domain allowed to transition.
+##	Domain allowed access.
 ##	</summary>
 ## </param>
-## <param name="object_class">
+## <param name="role">
+##	<summary>
+##	The role to be allowed to manage the kerberos domain.
+##	</summary>
+## </param>
+## <rolecap/>
+#
+interface(`kerberos_admin',`
+	gen_require(`
+		type kadmind_t, krb5kdc_t, kerberos_initrc_exec_t;
+		type kadmind_log_t, kadmind_tmp_t, kadmind_var_run_t;
+		type krb5_conf_t, krb5_keytab_t, krb5kdc_conf_t;
+		type krb5kdc_principal_t, krb5kdc_tmp_t, kpropd_t;
+		type krb5kdc_var_run_t, krb5_host_rcache_t;
+	')
+
+	allow $1 kadmind_t:process signal_perms;
+	ps_process_pattern($1, kadmind_t)
+	tunable_policy(`deny_ptrace',`',`
+		allow $1 kadmind_t:process ptrace;
+		allow $1 krb5kdc_t:process ptrace;
+		allow $1 kpropd_t:process ptrace;
+	')
+
+	allow $1 krb5kdc_t:process signal_perms;
+	ps_process_pattern($1, krb5kdc_t)
+
+	allow $1 kpropd_t:process signal_perms;
+	ps_process_pattern($1, kpropd_t)
+
+	init_labeled_script_domtrans($1, kerberos_initrc_exec_t)
+	domain_system_change_exemption($1)
+	role_transition $2 kerberos_initrc_exec_t system_r;
+	allow $2 system_r;
+
+	logging_list_logs($1)
+	admin_pattern($1, kadmind_log_t)
+
+	files_list_tmp($1)
+	admin_pattern($1, kadmind_tmp_t)
+
+	files_list_pids($1)
+	admin_pattern($1, kadmind_var_run_t)
+
+	admin_pattern($1, krb5_conf_t)
+
+	admin_pattern($1, krb5_host_rcache_t)
+
+	admin_pattern($1, krb5_keytab_t)
+
+	admin_pattern($1, krb5kdc_principal_t)
+
+	admin_pattern($1, krb5kdc_tmp_t)
+
+	admin_pattern($1, krb5kdc_var_run_t)
+')
+
+########################################
+## <summary>
+##	Type transition files created in /tmp
+##	to the krb5_host_rcache type.
+## </summary>
+## <param name="domain">
 ##	<summary>
-##	Class of the object being created.
+##	Domain allowed access.
 ##	</summary>
 ## </param>
 ## <param name="name" optional="true">
@@ -437,12 +402,13 @@ interface(`kerberos_tmp_filetrans_host_r
 		type krb5_host_rcache_t;
 	')
 
-	files_tmp_filetrans($1, krb5_host_rcache_t, $2, $3)
+	manage_files_pattern($1, krb5_host_rcache_t, krb5_host_rcache_t)
+	files_tmp_filetrans($1, krb5_host_rcache_t, file, $2)
 ')
 
 ########################################
 ## <summary>
-##	Connect to krb524 service.
+##	read kerberos homedir content (.k5login)
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -450,82 +416,85 @@ interface(`kerberos_tmp_filetrans_host_r
 ##	</summary>
 ## </param>
 #
-interface(`kerberos_connect_524',`
-	tunable_policy(`allow_kerberos',`
-		allow $1 self:udp_socket create_socket_perms;
-
-		corenet_all_recvfrom_unlabeled($1)
-		corenet_all_recvfrom_netlabel($1)
-		corenet_udp_sendrecv_generic_if($1)
-		corenet_udp_sendrecv_generic_node($1)
-
-		corenet_sendrecv_kerberos_master_client_packets($1)
-		corenet_udp_sendrecv_kerberos_master_port($1)
+interface(`kerberos_read_home_content',`
+	gen_require(`
+		type krb5_home_t;
 	')
+
+	userdom_search_user_home_dirs($1)
+	read_files_pattern($1, krb5_home_t, krb5_home_t)
 ')
 
 ########################################
 ## <summary>
-##	All of the rules required to
-##	administrate an kerberos environment.
+##	create kerberos content in the  in the /root directory
+##	with an correct label.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
 ##	Domain allowed access.
 ##	</summary>
 ## </param>
-## <param name="role">
+#
+interface(`kerberos_filetrans_admin_home_content',`
+	gen_require(`
+		type krb5_home_t;
+	')
+
+	userdom_admin_home_dir_filetrans($1, krb5_home_t, file, ".k5login")
+')
+
+########################################
+## <summary>
+##	Transition to kerberos named content
+## </summary>
+## <param name="domain">
 ##	<summary>
-##	Role allowed access.
+##      Domain allowed access.
 ##	</summary>
 ## </param>
-## <rolecap/>
 #
-interface(`kerberos_admin',`
+interface(`kerberos_filetrans_home_content',`
 	gen_require(`
-		type kadmind_t, krb5kdc_t, kerberos_initrc_exec_t;
-		type kadmind_log_t, kadmind_tmp_t, kadmind_var_run_t;
-		type krb5_conf_t, krb5_keytab_t, krb5kdc_conf_t;
-		type krb5kdc_principal_t, krb5kdc_tmp_t, kpropd_t;
-		type krb5kdc_var_run_t, krb5_host_rcache_t;
+		type krb5_home_t;
 	')
 
-	allow $1 { kadmind_t krb5kdc_t kpropd }:process { ptrace signal_perms };
-	ps_process_pattern($1, { kadmind_t krb5kdc_t kpropd })
-
-	init_labeled_script_domtrans($1, kerberos_initrc_exec_t)
-	domain_system_change_exemption($1)
-	role_transition $2 kerberos_initrc_exec_t system_r;
-	allow $2 system_r;
-
-	logging_list_logs($1)
-	admin_pattern($1, kadmind_log_t)
-
-	files_list_tmp($1)
-	admin_pattern($1, { kadmind_tmp_t krb5_host_rcache_t krb5kdc_tmp_t })
-
-	kerberos_tmp_filetrans_host_rcache($1, file, "host_0")
-	kerberos_tmp_filetrans_host_rcache($1, file, "HTTP_23")
-	kerberos_tmp_filetrans_host_rcache($1, file, "HTTP_48")
-	kerberos_tmp_filetrans_host_rcache($1, file, "imap_0")
-	kerberos_tmp_filetrans_host_rcache($1, file, "nfs_0")
-	kerberos_tmp_filetrans_host_rcache($1, file, "ldapmap1_0")
-	kerberos_tmp_filetrans_host_rcache($1, file, "ldap_487")
-	kerberos_tmp_filetrans_host_rcache($1, file, "ldap_55")
-
-	files_list_pids($1)
-	admin_pattern($1, { kadmind_var_run_t krb5kdc_var_run_t })
+	userdom_user_home_dir_filetrans($1, krb5_home_t, file, ".k5login")
+')
 
-	files_list_etc($1)
-	admin_pattern($1, krb5_conf_t)
+########################################
+## <summary>
+##	Transition to kerberos named content
+## </summary>
+## <param name="domain">
+##	<summary>
+##      Domain allowed access.
+##	</summary>
+## </param>
+#
+interface(`kerberos_filetrans_named_content',`
+	gen_require(`
+		type krb5_conf_t, krb5_keytab_t, krb5kdc_conf_t;
+		type krb5kdc_principal_t;
+	')
 
 	files_etc_filetrans($1, krb5_conf_t, file, "krb5.conf")
-
-	admin_pattern($1, { krb5_keytab_t  krb5kdc_principal_t })
-
+	filetrans_pattern($1, krb5kdc_conf_t, krb5_keytab_t, file, "kadm5.keytab")
 	filetrans_pattern($1, krb5kdc_conf_t, krb5kdc_principal_t, file, "principal")
 	filetrans_pattern($1, krb5kdc_conf_t, krb5kdc_principal_t, file, "principal0")
 	filetrans_pattern($1, krb5kdc_conf_t, krb5kdc_principal_t, file, "principal1")
+	#filetrans_pattern($1, krb5kdc_conf_t, krb5kdc_principal_t, file, "principal1")
+
+	kerberos_etc_filetrans_keytab($1, "krb5.keytab")
+	kerberos_filetrans_admin_home_content($1)
 
-	kerberos_etc_filetrans_keytab($1, file, "kadm5.keytab")
+	kerberos_tmp_filetrans_host_rcache($1, "DNS_25")
+	kerberos_tmp_filetrans_host_rcache($1, "host_0")
+	kerberos_tmp_filetrans_host_rcache($1, "HTTP_23")
+	kerberos_tmp_filetrans_host_rcache($1, "HTTP_48")
+	kerberos_tmp_filetrans_host_rcache($1, "imap_0")
+	kerberos_tmp_filetrans_host_rcache($1, "nfs_0")
+	kerberos_tmp_filetrans_host_rcache($1, "ldapmap1_0")
+	kerberos_tmp_filetrans_host_rcache($1, "ldap_487")
+	kerberos_tmp_filetrans_host_rcache($1, "ldap_55")
 ')
